#!/bin/bash
# Based on IEs 4 Linux project code
# 	Developed by: Sergio Luis Lopes Junior <slopes at gmail dot com>
# 	Project site: http://tatanka.com.br/ies4linux
# 	Released under the GNU GPL. See LICENSE for more information
#
# This code is a modification done by Vit Hrachovy for wine-doors project
# http://www.wine-doors.org
#
# Hacked by Andrew Stormont <andyjstormont@googlemail.com>


WINEDIR="${WINEPREFIX}/drive_c"

echo Discover Wine folders
	WINDOWS=Windows
	SYSTEM=system
	SYSTEM32=System32
	FONTS=Fonts
	INF=Inf
	COMMAND=Command
	if [ -d "${WINEDIR}/windows" ]; then WINDOWS=windows; fi
	if [ -d "${WINEDIR}/${WINDOWS}/system32" ]; then SYSTEM32=system32; fi
	if [ -d "${WINEDIR}/${WINDOWS}/fonts" ]; then FONTS=fonts; fi
	if [ -d "${WINEDIR}/${WINDOWS}/inf" ]; then INF=inf;fi
	if [ -d "${WINEDIR}/${WINDOWS}/command" ]; then COMMAND=command;fi 
	export WINDOWS SYSTEM FONTS INF COMMAND
	mkdir -p "${WINEDIR}/${WINDOWS}/${SYSTEM}"
	mkdir -p "${WINEDIR}/${WINDOWS}/${FONTS}"
	mkdir -p "${WINEDIR}/${WINDOWS}/${INF}"
	mkdir -p "${WINEDIR}/${WINDOWS}/${COMMAND}"
	OLDPWD=`pwd`
#TODO: rm -rf should be avoided 
	# symlinking system to system32
	if [ -d "${WINEDIR}/${WINDOWS}/${SYSTEM32}" ]; then 
		mv -f "${WINEDIR}/${WINDOWS}/"{S,s}ystem/* "${WINEDIR}/${WINDOWS}/${SYSTEM32}"
		rm -rf "${WINEDIR}/${WINDOWS}/"{S,s}ystem
		cd "${WINEDIR}/${WINDOWS}/"
		ln -s "${SYSTEM32}" "system"
	fi
	cd $OLDPWD
echo Extract CABs
		 
	cabextract -Lq "resources"/{ADVAUTH,CRLUPD,HHUPD,IEDOM,IE_EXTRA,IE_S*,SCR56EN,SETUPW95,VGX}.CAB
#				    ADVAUTH,CRLUPD,HHUPD,IEDOM,IE_EXTRA,IE_S*,SCR56EN,SETUPW95,VGX
	cabextract -Lq ie_1.cab
	rm -f *cab regsvr32.exe setup*

echo Processing INF
	for i in *.inf; do
		wine rundll32 setupapi.dll,InstallHinfSection DefaultInstall 128 ./$i &> /dev/null
	done
	rm *hlp
echo Install IE 6
	mv *.inf "${WINEDIR}/${WINDOWS}/${INF}/"
	mv cscript.exe "${WINEDIR}/${WINDOWS}/${COMMAND}/"
	mv wscript.exe "${WINEDIR}/${WINDOWS}/"
	
	mv sch128c.dll  "${WINEDIR}/${WINDOWS}/${SYSTEM}/schannel.dll"
	mkdir -p "${WINEDIR}/Program Files/Internet Explorer"
	mv iexplore.exe "${WINEDIR}/Program Files/Internet Explorer/iexplore.exe"
	
	mkdir -p "${WINEDIR}/${WINDOWS}/${SYSTEM}/sfp/ie/"
	mv vgx.cat "${WINEDIR}/${WINDOWS}/${SYSTEM}/sfp/ie/vgx.cat"
	
echo IE6 install Cleanup
	find "${WINEDIR}/${WINDOWS}/${SYSTEM}/" -type f -exec chmod 644 {} \;
	find "${WINEDIR}/${WINDOWS}/${SYSTEM}/" -type d -exec chmod 755 {} \;
	mv acmsetup.exe actxprxy.dll advapi32.dll advauth.cat advpack.dll asctrls.ocx \
atl.dll bindfile.dll browselc.dll browseui.dll browsewm.dll certmgr.msc \
ckcnv.exe comctl32.dll cool.dll corpol.dll cp_20866.nls cp_28591.nls \
cp_28592.nls cp_28595.nls cp_28597.nls cryptdlg.dll cryptext.dll cryptnet.dll \
cryptui.dll crypt32.dll csseqchk.dll dhtmled.ocx digest.dll \
dssbase.dll dsssig.exe dwintl.dll dw15.exe dxtmsft.dll dxtrans.dll \
enhsig.dll extrac32.exe grpconv.exe hhctrl.ocx hh.exe hhsetup.dll \
hlink.dll hmmapi.dll html32.cnv iebatch.exe ie.cat iedkcs32.dll \
ieinfo5.mof ieinfo5.ocx iejit.htm iemigrat.dll iepeers.dll iernonce.dll iesetup.dll \
ie4.dll ie4uinit.exe imagehlp.dll imgutil.dll inetcplc.dll inetcpl.cpl \
initpki.dll inseng.dll instrsa.dll instsch.dll itircl.dll itss.dll \
jitalert.gif jobexec.dll jsproxy.dll license.txt licmgr10.dll \
loadwc.exe migrate.dll mlang.dll mmutilse.dll mscat32.dll msconv97.dll \
mscrlrev.dll msdatsrc.tlb msencode.dll mshta.exe mshtml.dll mshtmled.dll \
mshtmler.dll mshtml.tlb msident.cat msident.dll msidntld.dll msls31.dll \
msoss.dll msratelc.dll msrating.dll mssetup.dll mssign32.dll mssip32.dll \
mstime.dll msvcrt.dll msxmla.dll msxml.dll msxmlr.dll msxml3a.dll \
msxml3.dll msxml3r.dll nashbase.stf occache.dll pingname.bat pingnum.bat \
plugin.ocx pngfilt.dll proctexe.ocx psbase.dll pstorec.dll pstorerc.dll \
pstores.exe related.htm rmm.pdr rnaph.dll rsabase.dll rsaci.rat \
rsaenh.dll rsasig.dll sendmail.dll shdoclc.dll \
shdocvw.dll shdoc401.dll shd401lc.dll shfolder.dll shlwapi.dll simpdata.tlb softpub.dll \
srgb.icm start.wav support.txt thumbvw.dll tip.htm tips.gif triedit.dll \
t2embed.dll updcrl.exe url.dll urlmon.dll userstub.exe \
verisignpub1.crl vgx.dll wallpapr.htm wininet.dll wintrust.dll wldap32.dll xenroll.dll \
	 "${WINEDIR}/${WINDOWS}/${SYSTEM}/"
	#wine regedit "resources/homepage.reg"  &> /dev/null
echo Simulate Windows boot
	wineboot -r &
	sleep 5
	killall -9 wine
	killall -9 winedbg
	find "${WINEDIR}/${WINDOWS}/${SYSTEM}/" -exec chmod 755 {} \;

# Evil hack
exit 0
